{
open DpYacc;;
open Utilities;;
}

rule token = parse
  ['-']*['0'-'9']+   {INT (int_of_string (Lexing.lexeme lexbuf))}
  |(['a'-'z' 'A'-'Z' ',' '.' ';' ':' '?' '!' '\'' '\\' '-' '%' '@' '/' '(' ')' '$' '0'-'9' '^' '*' '`' '&' '#' '_' '+' '=' '"' '<' '>' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '']+)      {STRING (Lexing.lexeme lexbuf)}
  |['\t']+   {TABS}
  |['\t']    {TAB}
  |[^ '\n']*eof  {EOF}
  |[^ '\n']    {token lexbuf}
  |[' ']+       {token lexbuf}
  |['\n']     {linenum := !linenum + 1;EOL} 
  |eof       {EOF}




